//MACROS MEUBLES
/////////////////////////////////////////////////////////
/*
Ce fichier comprend le mobilier de la maison, regroup
par pices,  savoir :
	- le salon :
		-	un fauteuil compos de plusieurs lements
			individuels, en bois pour le socle et en
			tissu pour les coussins ;
		-	une table basse, avec des pieds en bois et
			un plateau en verre ;
		-	une lampe  pied, avec socle et pied en 
			mtal, et abat-jour tissu ;
		-	une grande coupe mtallique.
	- la salle  manger :
		-	une table en bois ;
		-	quatre chaises en bois assorti, avec des
			coussins en tissu ;
		-	un napperon en tissu ;
		-	un vase en mtal.
	- la chambre :
		-	un lit en bois avec chevet et lampes intgrs,
			avec matelas ;
		-	deux oreillers tissu ;
		-	un dredon tissu.
	- une salle de bureau :
		-	un bureau bois ;
		-	trois chaises bois avec coussin tissu ;
		-	un range-documents ;
		-	un pot  crayons ;
		-	une lampe cylindrique.
	- un atelier d'architecture :
		-	deux bureaux bois ;
		-	deux chaises bois ;
		-	trois lampes cubes de diffrentes tailles.		 
*/
/////////////////////////////////////////////////////////

//TEXTURES

#macro texture_bois1() 
	texture
	{	pigment
		{	wood
			color_map
			{
				[ 0.4 color rgb <0.3,0.2,0.2> ]
				[ 0.5 color rgb <1,0.2,0.3> ]
				[ 0.6 color rgb <0.3,0.2,0.3> ]
			}
			turbulence 0.8
			rotate <0,0,30>
			scale 1/32
		}
		finish
		{	ambient 0.2
			diffuse 0.7
			specular 0.7
			roughness 0.1
			//reflection 0.2
		}
	}
#end

#macro texture_bois2() 
	texture
	{	pigment
		{	wood
			color_map
			{
				[ 0.4 color rgb <0.9,0.7,0.5> ]
				[ 0.5 color rgb <1,0.5,0.3> ]
				[ 0.6 color rgb <0.8,0.6,0.55> ]
			}
			turbulence 0.8
			rotate <0,0,30>
			scale 1/32
		}
		finish
		{	ambient 0.2
			diffuse 0.7
			specular 0.7
			roughness 0.1
			//reflection 0.2
		}
	}
#end


#macro texture_bois() 
	texture
	{	pigment
		{	wood
			color_map
			{
				[ 0.4 color rgb <0.55,0.3,0.2> ]
				[ 0.5 color rgb <0.3,0.4,0.2> ]
				[ 0.6 color rgb <0.45,0.3,0.1> ]
			}
			turbulence 0.8
			rotate <0,0,30>
			scale 1/32
		}
		finish
		{	ambient 0.2
			diffuse 0.7
			specular 0.7
			roughness 0.1
			//reflection 0.2
		}
	}
#end


#macro texture_verre()
	pigment
	{	color rgbt <0,0,0.2,0.9> }
	finish
	{	reflection 0.5	}
#end


#macro texture_coussin()
	pigment
	{	color rgb <1,1,1>  }
	finish
	{	ambient 0.2
		diffuse 0.7
		specular 0.7
		roughness 0.5	}
#end


#macro texture_metal()
	pigment
	{	color rgb <0.6,0.6,0.6> }
	finish
	{	reflection 0.6
		ambient 0.4
		diffuse 0.2
		specular 0.5
	}
#end


#macro texture_beton()
	texture
	{
		pigment
		{	granite
			color_map
			{
				[ 0.4 color rgb <0.85,0.85,0.85> ]
				[ 0.5 color rgb <0.9,0.9,0.9> ]
				[ 0.6 color rgb <0.8,0.8,0.8> ]
			}
			turbulence 1
			rotate <0,0,0>
			scale 1/2
			}
		finish
		{	ambient 0.1
			diffuse 0.01
			specular 0.7
			roughness 0.5
			reflection 0.05
		}
	} 
#end
	
/////////////////////////////////////////////////////////

// GEOMETRIE


/// SALON

#macro salon( position, rotation )
	union
	{	fauteuil( <0,0,0> , <0,0,0> )
		table_basse( <1.25,0,1.3> )
		saladier( <1.7,0.65,1.9> )
		//lampe_salon( <-0.3,0,0.5> )
		translate position
		rotate rotation
	}
#end


//// TABLE BASSE

#macro pied_table_basse( position )
	box 
		{	<0,0,0>
			<0.15,0.3,0.15>
			translate position
			texture_bois2()
		}
#end


#macro plateau_table_basse( position )
	box 
		{	<0,0,0>
			<0.9,0.025,0.9>
			translate position
			texture_verre()
		}
#end


#macro table_basse( position )
	union
		{	pied_table_basse( <0,0,0> )
			pied_table_basse( <0.75,0,0> )
			pied_table_basse( <0,0,0.75> )
			pied_table_basse( <0.75,0,0.75> )
			plateau_table_basse( <0,0.3,0> )
			translate position
		}
#end

//// SALADIER

#macro saladier( position )
	difference
	{	sphere
		{	<0,0,0>     
			0.3               
		}
		sphere
		{	<0,0,0>     
			0.28               
		}
		box
		{	<1,-0.15,1>     
			<-1,0.4,-1>      
		}
		texture_metal()  
		translate position
	}
#end


//// FAUTEUIL

#macro socle_fauteuil1( position )
	box
	{	<0,0,0>
		<0.85,0.15,0.85>
		pigment {color <1,1,1> }
		translate position
		texture_bois2()
	}
#end


#macro dossier_fauteuil1( position )
	box
	{	<0,0,0>
		<0.15,0.45,0.85>
		pigment {color <1,1,1> }
		translate position
		texture_bois2()
	}
#end


#macro coussin_fauteuil1( position )
	union
		{	box
		{	<0,0,0>
			<0.7,0.15,0.85>
			translate position
		}
		box
		{	<0,0.15,0>
			<0.15,0.45,0.85>
			translate position
		}
		texture_coussin()
	}
#end


#macro fauteuil1( position, rotation )
	union
	{	socle_fauteuil1( <0,0,0> )
		dossier_fauteuil1( <0,0.15,0> )
		coussin_fauteuil1( <0.15,0.15,0> )
		translate position
		rotate rotation
	}
#end


#macro socle_fauteuil2( position )
	box
	{
		<0,0,0>
		<0.85,0.15,0.85>
		pigment {color <1,1,1> }
		translate position
		texture_bois2()
	}
#end


#macro dossier_fauteuil2( position )
	union
	{	box
		{	<0,0,0>
			<0.15,0.45,0.85>
			pigment {color <1,1,1> }
			translate position
			texture_bois2()
		}
		box
		{	<0.15,0,0>
			<0.85,0.45,0.15>
			pigment {color <1,1,1> }
			translate position 
			texture_bois2()
		}
	}
#end


#macro coussin_fauteuil2( position )
	union
	{	box
		{	<0,0,0>
			<0.7,0.15,0.7>
			texture_coussin()
		}
		box
		{	<0,0.15,0.15>
			<0.7,0.45,0>
			texture_coussin()
		}
		box
		{	<0,0.15,0.15>
			<0.15,0.45,0.7>
			texture_coussin()
		}
		translate position
	}
#end


#macro fauteuil2( position, rotation )
	union
	{	socle_fauteuil2( <0,0,0> )
		dossier_fauteuil2( <0,0.15,0> )
		coussin_fauteuil2( <0.15,0.15,0.15> )
		translate position
		rotate rotation
	}
#end


#macro fauteuil( position, rotation )
	union
	{	fauteuil1( <0,0,0.85>, <0,0,0> )
		fauteuil2( <0,0,0>, <0,0,0> )
		fauteuil1( <0,0,-1.7>, <0,-90,0> )
		fauteuil1( <0,0,-2.55>, <0,-90,0> )
		fauteuil2( <0,0,-3.4>, <0,-90,0> )
		fauteuil1( <-3.4,0,-1.7>, <0,180,0> )
		translate position
		rotate rotation
	}
#end


/// CHAMBRE

#macro chambre( position, rotation )
	union
	{	lit( <0,0,0> )
		oreiller( <2,-4,-1>, <0,0,90>, 1/4 )
		oreiller( <2,-7,-1>, <0,0,90>, 1/4 )
		edredon( <0.54,-1.7,-1.5>, <0,0,90>, 0.8 )
		chevet(<0,0.4,0> )
		chevet(<2.25,0.4,0> )
		lampe_boule( <0.2,0.75,-0.01>, <0.2,-0.2,-0.2>, 50, <1,1,1> )
		lampe_boule( <2.45,0.75,-0.01>, <-0.2,-0.2,-0.2>, 50, <1,1,1> )
		translate position
		rotate rotation
	}
#end

 

//// LIT

#macro tete_lit()
	box
	{	<0,0,0>      						
		<2.7,0.9,0.1>      					
		texture_bois1() 	 		
	}
#end


#macro sommier_lit()
	box
	{	<0.6,0.2,0>							
		<2.1,0.25,-2>						
		texture_bois1() 	 		
	}
#end


#macro matelas_lit()
	box
	{	<0.6,0.25,0>						
		<2.1,0.5,-2>						
		texture_coussin() 	 		
	}
#end


#macro lit( position )
	union
	{	tete_lit()
		sommier_lit()
		matelas_lit()
		translate position
	}
#end


//// OREILLER

#macro oreiller( position, rotation, echelle )
	object
	{	superellipsoid { <1/2,1/2> scale <1/8,1,1> }
		pigment {	color rgb <1,0.9,1>  }
		translate position
		rotate rotation
		scale echelle
	}
#end


//// EDREDON

#macro edredon( position, rotation, echelle )
	object
	{	superellipsoid { <1/16,1/16> scale <1/8,1,1> }
		pigment {	color rgb <1,0.9,1>  }
		translate position
		rotate rotation
		scale echelle
	}
#end


//// CHEVET

#macro chevet( position )
	box
	{	<0,0,0>
		<0.45,0.05,-0.30>
		translate position
		texture_bois1()
	}
#end


//// LAMPE BOULE

#macro lampe_boule( pos, cible, rayon, couleur )
	light_source
	{	<0,0,0>                			 
	  	color rgb couleur       
	  	spotlight              
	  	point_at cible    	 
	  	radius rayon              		
	  	tightness 0.5           			
	  	falloff rayon+10             	
	  	looks_like 
	  		{	sphere
	  			{ <0,0,0>, 0.08 }	
	  			texture
	  			{	pigment { color rgb couleur } 
	  		 		finish { ambient 1 } 	
	  		 	}
	 		 }
	  		 translate pos					
	}
#end



/// SALLE A MANGER

#macro salle_a_manger( position, rotation )
	union
	{	bureau( <0,0,0> )
		chaise( <0.3,0,-0.2>, <0,0,0> )
		chaise( <1.05,0,-0.2>, <0,0,0> )
		chaise( <-0.75,0,-1.15>, <0,180,0> )
		chaise( <-1.5,0,-1.15>, <0,180,0> )
		vase( <0.9,0.75,0.45> )
		napperon( <0,0.36,0.25> )
		lampe_suspendue( <0.525,1.4,0.45>, <0,-0.5,0>, 25 )
        lampe_suspendue( <1.275,1.4,0.45>, <0,-0.5,0>, 25 )
		translate position
		rotate rotation
	}
#end


/// SALLE BUREAU

#macro salle_bureau( position, rotation )
	union
	{	bureau( <0,0,0> )
		chaise( <0.3,0,-0.45>, <0,0,0> )
		chaise( <1.05,0,-0.45>, <0,0,0> )
		chaise( <-1.125,0,-1.25>, <0,180,0> )
		lampe_cylindre( <1.65,0.75,0.15> )
		range_documents( <0.5,0.75,0.5> )
		pot_a_crayons( <0.4,0.75,0.45>)
		translate position
		rotate rotation
	}
	#end


/// ATELIER ARCHI

#macro atelier_archi( position, rotation )
	union
		{	bureau( <0,0,-0.9> )
			chaise( <0.675,0,-0.2>, <0,0,0> )
			bureau( <-1.8,0,-0.9> )
			chaise( <-1.125,0,-0.2>, <0,0,0> )
			lampe_carree( <-0.45,0.75,0.4>, <0.25,0.25,0.25>, <0,50,0> )
			lampe_carree( <-0.5,0.75,-0.6>, <0.2,0.2,0.2>, <0,120,0> )
			lampe_carree( <0.3,0.75,-0.8>, <0.15,0.15,0.15>, <0,170,0> )
			range_documents( <-1.3,0.75,-0.4> )
			range_documents( <0.5,0.75,-0.4> )
			translate position
			rotate rotation 
		}
	#end


//// BUREAU

#macro bureau( position )
	difference
	{	box
		{	<0,0,0>      						
			<1.8,0.75,0.9>      				
		}
		box
		{	<0.1,-10,-10>      				
			<1.7,0.7,100>      				
		}
		texture_bois()
		translate position
		rotate rotation
	}
#end


//// CHAISE

#macro chaise( position, rotation )
	union
	{	difference
		{
			box
			{	<0,0,0>								
				<0.45,0.9,0.45>						
			}
			box
			{	<-10,0.05,-10>						
				<0.75,0.4,0.4>						
			}
			box
			{	<-10,0.45,0.05>						
				<0.75,1,0.55>						
			}
			box
			{	<0.1,-0.1,-1>						
				<0.35,0.35,0.55>					
			}
			box
			{	<0.2,0.45,-0.1>						
				<0.25,1.05,0.25>					
			}
			texture_bois()
			translate position
			rotate rotation
		}
		box
		{	<0,0.45,0.05>
			<0.45,0.46,0.45>
			translate position
			rotate rotation
			texture_coussin()
		}
	}
#end


//// VASE

#macro vase( position )
	difference
	{	cylinder
		{	<0,0,0>
			<0,0.3,0>
			0.1
		}
		cylinder
		{	<0,0.02,0>
			<0,0.35,0>
			0.08
		}	
		texture_metal()
		translate position
		rotate rotation
	}
#end


//// NAPPERON

#macro napperon( position )
	difference
	{	box
		{	<0,0,0>     
			<1.81,0.4,0.4>      
		}
		box
		{	<0.05,-1,-1>     
			<1.8,0.39,1>      
		}
		texture_coussin()
		translate position
	}
#end


//// LAMPE CARREE

#macro lampe_carree( position, taille, rotation )
	light_source
	{	<0,0,0> 					        
 		color rgb <1,1,1>     
	    looks_like
		{	box	{	<0,0,0> taille }	
			texture
			{	pigment { color rgb <1,1,1>} 
				finish { ambient 1 }	
			}
		}
		translate position	
		rotate rotation
		}
#end


//// LAMPE SUSPENDUE

#macro lampe_suspendue( position, cible, rayon )
	union
	{	light_source
		{	<0,0,0> 					        
	 		color rgb <1,1,1>     
	 		spotlight              
	 		point_at cible      
	 		radius rayon           		
	 		tightness 1 	       		
			falloff rayon+10               
			looks_like
			{	cone
				{	<0,0.3,0>     //centre du premier disque
					0.01                   //son rayon
					<0,0,0>     //centre du deuxime disque
					0.25   
				}	
				texture
				{	pigment { color rgb <1,1,1>} 
					finish { ambient 1 }	
				}
			}
			}
		cylinder
		{	<0,0.3,0>
			<0,1.3,0>
			0.02
			texture_metal()
		}
		translate position	
	}
#end


//// LAMPE SALON

#macro lampe_salon( position )
	union
	{	light_source
		{	<0,0,0> 					        
	 		color rgb <1,1,1>     
	 		looks_like
			{	cylinder
				{	<0,1.35,0>     
					<0,1.85,0>     
					0.2                  
				}	
				texture
				{	pigment { color rgb <1,1,1>} 
					finish { ambient 1 }	
				}
			}
		}
		cylinder
		{	<0,0,0>
			<0,0.05,0>
			0.2
			texture_metal()
		}
		cylinder
		{	<0,0.05,0>
			<0,1.35,0>
			0.02
			texture_metal()
		}
		translate position	
	}
#end


//// LAMPE CYLINDRE

#macro lampe_cylindre( position )
	light_source
	{	<0,0,0> 					        
 		color rgb <1,1,1>     
  		looks_like
		{	cylinder
			{	<0,0,0>     
				<0,0.35,0>     
				0.09                  
			}	
			texture
			{	pigment { color rgb <1,1,1>} 
				finish { ambient 1 }	
			}
		}
		translate position
	}
#end


//// POT A CRAYONS
#macro pot_a_crayons( position )
	difference
	{	cylinder
		{	<0,0,0>
			<0,0.15,0>
			0.07
		}
		cylinder
		{	<0,0.01,0>
			<0,1,0>
			0.06
		}
		texture_metal()
		translate position
		rotate rotation
	}	
#end


//// RANGE DOCUMENTS
#macro range_documents( position )
	box
	{	<0,0,0>
		<0.8,0.01,0.4>
		translate position
		rotate rotation
		texture_coussin()
	}
#end

/////////////////////////////////////////////////////////
/*
// VISUALISATION

#macro eclairage_standard( nombre )
	#if (nombre=1)
		light_source { <-1,1,-1> color rgb <1,1,1> }	
	#end
	#if (nombre=2)	
		light_source { <-1,1,-1> color rgb <1,1,1> }	
		light_source { < 1,1,-1> color rgb <1,1,1> }
	#end
	#if (nombre=3)	
		light_source { <-1,1,-1> color rgb <1,1,1> }	
		light_source { < 1,1,-1> color rgb <1,1,1> }
		light_source { < 0,2, 2> color rgb <1,1,1> }
	#end
#end


#declare OX 	= 0;
#declare OY 	= 1;
#declare OZ 	= 2;
#declare AXO_1 	= 3;
#declare AXO_2 	= 4;
#declare AXO_3 	= 5;
#declare AXO_4 	= 6;

#macro axonometrie( vvv, zoom )
	#if (vvv = OX) camera { orthographic location <-1,0,0> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = OY) camera { orthographic location <0,-1,0> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = OZ) camera { orthographic location <0,0,-1> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = AXO_1) camera { orthographic location <-1,1,-1> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = AXO_2) camera { orthographic location < 1,1,-1> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = AXO_3) camera { orthographic location < 1,1, 1> look_at <0,0,0> scale 1/zoom } #end
	#if (vvv = AXO_4) camera { orthographic location <-1,1, 1> look_at <0,0,0> scale 1/zoom } #end
#end


#macro pers ( oeil, cible )
	camera { location oeil look_at cible }
#end


#macro sol( taille, translation )
	object
	{	box { <-taille,-0.01,-taille>, <taille,0.01,taille> }
		texture_beton()
		translate <0,translation, 0>
	}
#end
*/
/////////////////////////////////////////////////////////

// SCENES

#macro scene_salon()
	salon( <0,0,0> , <0,0,0> )
	pers( <3.8,1.3,2.5>, <0,0,0> )
	eclairage_standard( 3 )
	sol( 5, 0 )
#end
	

#macro scene_salle_a_manger()
	salle_a_manger( <0,0,0> , <0,0,0> )
	pers( <2.8,2,1.5>, <0,0,0> )
	eclairage_standard( 3 )
	sol( 5, 0 )
#end	


#macro scene_chambre()
	chambre( <0,0,0>, <0,250,0> )
	pers( <1,1.8,4>, <0,0,0> )
	eclairage_standard( 3 )
	sol( 5, 0 )
#end


#macro scene_salle_bureau()
	salle_bureau( <0,0,0> , <0,0,0> )
	pers( <2.8,1.8,1.8>, <0,0,0> )
	eclairage_standard( 3 )
	sol( 5, 0 )
#end

#macro scene_atelier_archi()
	atelier_archi( <0,0,0>, <0,180,0> )
	pers( <1.8,1.8,2.5>, <0,0,0> )
	eclairage_standard( 3 )
	sol( 5, 0 )
#end

/////////////////////////////////////////////////////////

// THE END !!!





	
	